﻿Type=Service
Version=2.22
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals
	Dim DOWNLOAD_ADDRESS As String="http://www.basic4ppc.com/android/images/wiki_logo.png"
	Dim DOWNLOAD_FILENAME As String="wiki_logo.png"
	
	'	DownloadId is a unique identifier assigned by the DownloadManager to this download task
	Dim DownloadId As Long
	Dim DownloadManager1 As DownloadManager
End Sub

Sub Service_Create
	'	RegisterReceiver enables DownloadManager to raise events
	DownloadManager1.RegisterReceiver("DownloadManager1")
	
	'	Utils is a helper code module
	If Utils.IsInitialized=False Then
		Utils.Initialize(DownloadManager1)
	End If
End Sub

Sub Service_Start (StartingIntent As Intent)
	Dim DownloadManagerRequest1 As DownloadManagerRequest
	DownloadManagerRequest1.Initialize(DOWNLOAD_ADDRESS)
	DownloadManagerRequest1.Description="DownloadManager demo"
	'	save the download to external memory
	'	note you must manually update your project's manifest file adding android.permission.WRITE_EXTERNAL_STORAGE
	DownloadManagerRequest1.DestinationUri="file://"&File.Combine(File.DirRootExternal, DOWNLOAD_FILENAME)
	DownloadManagerRequest1.Title=DOWNLOAD_FILENAME
	DownloadManagerRequest1.VisibleInDownloadsUi=True
	
	DownloadId=DownloadManager1.Enqueue(DownloadManagerRequest1)
End Sub

Sub Service_Destroy
	'	by unregistering the BroadcastReceiver the DownloadManager will no longer raise events
	DownloadManager1.UnregisterReceiver
End Sub

Sub DownloadManager1_DownloadComplete(DownloadId1 As Long)
	'	this does not guarantee that the download has actually successfully downloaded
	'	it means a DownloadMananger DownloadManagerRequest has completed
	'	we need to find that status of that request but only if that request matches the request we started
	
	If DownloadId=DownloadId1 Then
		'	this is the download request we started
		'	query the DownloadManager for info on this request
		Dim DownloadManagerQuery1 As DownloadManagerQuery
		DownloadManagerQuery1.Initialize
		DownloadManagerQuery1.SetFilterById(DownloadId)
		
		'	you must enable the SQL library to work with the Cursor object
		Dim StatusCursor As Cursor
		'	pass our DownloadManagerQuery to the DownloadManager
		StatusCursor=DownloadManager1.Query(DownloadManagerQuery1)
		If StatusCursor.RowCount>0 Then
			StatusCursor.Position=0	
			
			Dim StatusInt As Int
			StatusInt=StatusCursor.getInt(DownloadManager1.COLUMN_STATUS)
			Log("Download Status = "&Utils.GetStatusText(StatusInt))

			If StatusInt=DownloadManager1.STATUS_FAILED OR StatusInt=DownloadManager1.STATUS_PAUSED Then
				Dim ReasonInt As Int
				ReasonInt=StatusCursor.GetInt(DownloadManager1.COLUMN_REASON)
				Log("Status Reason = "&Utils.GetReasonText(ReasonInt))
			End If
			
			If StatusInt=DownloadManager1.STATUS_SUCCESSFUL Then
				CallSub2(Main, "ShowBitmap", LoadBitmap(File.DirRootExternal, DOWNLOAD_FILENAME))
			End If
		Else
			'	always check that the Cursor returned from the DownloadManager Query method is not empty
			Log("The DownloadManager has no trace of our request, it could have been cancelled by the user using the Android Downloads app or an unknown error has occurred.")
		End If
		
		StatusCursor.Close
		StopService("")
	End If
End Sub

Sub DownloadManager1_NotificationClicked(DownloadIds() As Long)
	'	this event will be raised if the user clicks the DownloadManager notification
	'	if the device Android API level is 11 or higher then DownloadIds will be an array of download request ids.
	'	onlower API levels DownloadIds will be Null
	
	Log("DownloadManager1_NotificationClicked our download request is: "&DownloadId)
	If DownloadIds<>Null Then
		Log("DownloadIds length is: "&DownloadIds.Length)
		Dim i As Int
		For i=0 To DownloadIds.Length-1
			Log("DownloadIds("&i&")="&DownloadIds(i))
		Next
	Else
		Log("DownloadIds is Null")
	End If
End Sub